#!/usr/bin/env node
import l from "node:path";
import p from "node:fs";
import L from "json5";
import y from "lodash.upperfirst";
import E from "lodash.camelcase";
import $ from "lodash.kebabcase";
import k from "lodash.lowerfirst";
import d from "lodash.template";
import { log as i, chalk as D, xPrompts as S } from "@done-coding/cli-utils";
import { OutputModeEnum as C, handler as w } from "@done-coding/cli-template";
import T from "yargs";
import { hideBin as _ } from "yargs/helpers";
import b from "lodash.curry";
var a = /* @__PURE__ */ ((e) => (e.ADD = "add", e.REMOVE = "remove", e.LIST = "list", e))(a || {});
const j = (e, t) => {
  if (!/^[a-zA-Z]+[a-zA-Z0-9-]*$/.test(e))
    return i.error("组件名只能包含字母、数字、中划线"), process.exit(1);
  const { nameExcludes: r } = t;
  return r.includes(e) ? (i.error(`组件名: ${e}是保留名称。
保留名称: ${r.join(",")}`), process.exit(1)) : !0;
}, f = {
  version: "0.2.4-alpha.0",
  name: "@done-coding/cli-component",
  description: "组件命令行工具",
  cliConfig: {
    namespaceDir: ".done-coding",
    moduleName: "component"
  }
}, { namespaceDir: A, moduleName: F } = f.cliConfig, M = () => l.resolve(A, F), N = () => ({
  execDir: process.cwd(),
  templateDir: M()
}), g = (e) => {
  const { series: t, name: r } = e, o = y(E(r)), c = k(o), s = $(o), m = t ? y(E(t)) : "", n = m ? `${m}${o}` : "", u = $(n);
  return {
    series: m,
    name: o,
    nameLowerFirst: c,
    nameKebab: s,
    fullName: n,
    fullNameKebab: u,
    cls: u
  };
}, K = (e) => ({
  $: "$",
  ...N(),
  ...g(e)
}), v = () => {
  const e = l.resolve(M(), "index.json");
  if (!p.existsSync(e))
    return i.error(`模块入口文件不存在: ${e}`), process.exit(1);
  const r = JSON.parse(p.readFileSync(e, "utf-8")).config;
  if (!r)
    return i.error(`配置文件相对路径不存在: ${r}`), process.exit(1);
  const o = l.resolve(
    l.dirname(e),
    r
  );
  if (!p.existsSync(o))
    return i.error(`配置文件不存在: ${o}`), process.exit(1);
  const c = L.parse(p.readFileSync(o, "utf-8")), s = N();
  return c.componentDir = d(c.componentDir)(s), c;
}, x = (e) => {
  const { componentDir: t, nameExcludes: r } = e;
  return p.statSync(t).isDirectory() ? p.readdirSync(t).map((m) => {
    const n = l.join(t, m);
    return p.statSync(n).isDirectory() ? (console.log("filePath:", n, l.basename(n)), l.basename(n)) : "";
  }).filter((m) => !(!m || r.includes(m))) : (i.error("组件源码路径不是目录"), process.exit(1));
}, U = async () => {
  i.stage("展示列表");
  const e = v(), t = x(e);
  console.table(
    t.map((r) => {
      const { name: o, fullName: c } = g({
        ...e,
        name: r
      });
      return {
        [D.green("名称")]: o,
        [D.green("带系列名称")]: c,
        [D.green("绝对路径")]: l.resolve(e.componentDir, r)
      };
    })
  );
}, R = async ({
  name: e,
  config: t,
  command: r
}) => {
  if (![a.ADD, a.REMOVE].includes(r))
    return i.error(`不支持组件${r}操作`), process.exit(1);
  const o = K({
    ...t,
    name: e
  }), c = JSON.stringify(o);
  for (const { entry: s, index: m } of t.list) {
    if (s) {
      const n = s;
      n != null && n.input && (n.input = d(n.input)(o)), n != null && n.output && (n.output = d(n.output)(o));
      const u = {
        ...s,
        envData: c,
        mode: C.APPEND,
        rollback: r === a.REMOVE,
        dealMarkdown: !0
      };
      await w(u);
    }
    if (m) {
      const n = m;
      n != null && n.input && (n.input = d(n.input)(o)), n != null && n.output && (n.output = d(n.output)(o));
      const u = {
        ...m,
        envData: c,
        mode: C.OVERWRITE,
        rollback: r === a.REMOVE,
        dealMarkdown: !0
      };
      await w(u);
    }
  }
}, z = async ({ name: e }) => {
  i.stage("添加组件");
  let t;
  e ? t = e : t = (await S({
    type: "text",
    name: "name",
    message: "请输入组件名"
  })).name;
  const r = v();
  j(t, r);
  const { series: o } = r, c = await x(r);
  for (let s of c)
    if (g({
      series: o,
      name: t
    }).nameKebab === s)
      return i.error(`组件${s}已存在, 不能再次创建${t}组件`), process.exit(1);
  return R({
    name: t,
    config: r,
    command: a.ADD
  });
}, H = async ({ name: e }) => {
  i.stage("移除组件");
  const t = v(), r = await x(t);
  if (r.length === 0)
    return i.error("组件列表为空"), process.exit(1);
  let o;
  e ? o = e : o = (await S({
    type: "select",
    name: "name",
    message: "请选择要移除的组件",
    choices: r.map((s) => ({ title: s, value: s }))
  })).name;
  const { series: c } = t;
  for (let s of r)
    if (g({
      series: c,
      name: o
    }).nameKebab === s) {
      await R({
        name: o,
        config: t,
        command: a.REMOVE
      }), p.rmdirSync(l.resolve(t.componentDir, s));
      return;
    }
  return i.error(`组件${o}不存在`), process.exit(1);
}, h = async (e, t) => e === a.ADD ? z(t) : e === a.REMOVE ? H(t) : e === a.LIST ? U() : (i.error(`无效的命令: ${e}`), process.exit(1)), P = async (e) => {
}, V = f.cliConfig.moduleName, J = (e, t) => {
  e ? i.error(e) : i.error(t.message), process.exit(1);
}, Z = f.description, B = `Usage: $0 ${V} <command> [options]`, W = "Usage: $0 <command> [options]", O = (e) => e.command({
  command: `${a.ADD} <name>`,
  describe: "新增一个组件",
  builder: (t) => t.positional("name", {
    describe: "组件名称",
    type: "string"
  }),
  async handler(t) {
    return await b(h)(a.ADD)(t), process.exit(0);
  }
}).command({
  command: `${a.REMOVE} [name]`,
  describe: "删除一个组件",
  builder: (t) => t.positional("name", {
    describe: "组件名称",
    type: "string"
  }),
  async handler(t) {
    return await b(h)(a.REMOVE)(t), process.exit(0);
  }
}).command({
  command: a.LIST,
  describe: "展示组件列表",
  async handler(t) {
    return await b(h)(a.LIST)(t), process.exit(0);
  }
}).demandCommand(1), I = (e, t = !1) => t ? O(e.strict().usage(B)) : O(
  e.strict().usage(W).help("help").version(f.version).alias("v", "version").alias("h", "help")
).fail(J).argv, q = (e) => I(e, !0), le = {
  command: V,
  describe: Z,
  builder: q,
  handler: P
}, pe = async () => {
  const e = T(_(process.argv));
  return await I(e), P();
};
export {
  le as a,
  pe as c,
  P as h
};
